## tagainijisho 0.9.4

=== CMakeLists.txt ===
# The project name decides the naming pattern of many things - choose it according
# to the standard of the platform we run on.
if(APPLE)
	project("Tagaini Jisho")
else(APPLE)
	project("tagainijisho")
endif(APPLE)

# Set the program name to be the same as the project
set(tagaini_binary ${CMAKE_PROJECT_NAME})

set(VERSION 0.9.4)

cmake_minimum_required(VERSION 2.8.0)

find_package(Qt4 4.5 REQUIRED)
# FIXME only required when CMake downloads dictionary files. Not necessary for building from source package.
find_program(GUNZIP NAMES gunzip REQUIRED)

# Global GCC options
if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wnon-virtual-dtor -Wno-unused-parameter -fno-exceptions -fno-rtti")
endif(CMAKE_COMPILER_IS_GNUCC)

# Add the default database lookup data path for Linux if not defined
if(UNIX AND NOT APPLE AND NOT DATA_DIR)
	set(DATA_DIR "${CMAKE_INSTALL_PREFIX}/share/tagainijisho")
endif(UNIX AND NOT APPLE AND NOT DATA_DIR)

# 64 bits Intel binary with 10.6 compatibility 
if(APPLE)
	set(CMAKE_OSX_ARCHITECTURES "${ARCHS_STANDARD_64_BIT}")
	set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk")
	set(CMAKE_OSX_DEPLOYMENT_TARGET "10.6")
	set(CMAKE_PREFIX_PATH "${CMAKE_OSX_SYSROOT}/usr")  
	set(CMAKE_FRAMEWORK_PATH "${CMAKE_OSX_SYSROOT}/Library/Frameworks:${CMAKE_OSX_SYSROOT}/System/")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -sectcreate __TEXT __info_plist ${CMAKE_BINARY_DIR}/src/gui/Tagaini\\ Jisho.app/Contents/Info.plist")
	set(extra_link_flags "-bind_at_load")
endif(APPLE)
if(WIN32)
	set(extra_link_flags "-static-libgcc -static-libstdc++ -mwindows")
endif(WIN32)

# By default, enable all languages
if(NOT DICT_LANG)
	set(DICT_LANG "fr;de;es;ru;it;pt;th;tr")
endif()
# Set DICT_LANG to always appear in the cache
set(DICT_LANG ${DICT_LANG} CACHE STRING "Languages to use for the dictionary data (semicolon-separated 2-letter codes)")

# Debug options
option(DEBUG_ENTRIES_CACHE "Debug entries cache behavior" OFF)
option(DEBUG_PATHS "Debug files lookup" OFF)
option(DEBUG_DETAILED_VIEW "Debug detailed view output" OFF)
option(DEBUG_QUERIES "Debug SQL queries" OFF)
option(DEBUG_TRANSACTIONS "Debug database transactions" OFF)
option(DEBUG_LISTS "Debug lists (very slow)" OFF)

# Build tests suite?
option(BUILD_TESTS "Build tests suite" OFF)

# Databases helper targets
add_custom_target(databases ALL)

# i18n
add_subdirectory(i18n)

# Source code
add_subdirectory(src)

# Docs
add_subdirectory(doc)

# Packaging stuff
add_subdirectory(pack)

# External resources fetching and generation
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/)
	FILE(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty/)
endif()

# Uninstall
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== i18n/CMakeLists.txt ===
file(GLOB TSFILES ${CMAKE_CURRENT_SOURCE_DIR}/*.ts)
set(TRANSLATIONS_FILES "")
foreach(tsfile ${TSFILES})
	if (NOT ${tsfile} MATCHES ".*_en\\.ts")
		set(TRANSLATIONS_FILES "${TRANSLATIONS_FILES};${tsfile}")
	endif()
endforeach()

QT4_ADD_TRANSLATION(QM_FILES ${TRANSLATIONS_FILES})
add_custom_target (i18n ALL DEPENDS ${QM_FILES})

set(UI_LANG "")
foreach(tsfile ${TRANSLATIONS_FILES})
	string(REGEX REPLACE ".*_(..)\\.ts" "\\1" rmatch ${tsfile})
	set(UI_LANG "${UI_LANG};${rmatch}")
endforeach(tsfile ${TRANSLATIONS_FILES})

set(UI_LANG ${UI_LANG} CACHE STRING "Languages to be used for the UI")

=== pack/CMakeLists.txt ===
# Packaging and install. Warning : not for faint of the heart
set(CPACK_PACKAGE_NAME "Tagaini Jisho")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A Free Japanese dictionary and study assistant")
set(CPACK_PACKAGE_VENDOR "tagaini.net")
set(CPACK_PACKAGE_CONTACT http://www.tagaini.net)
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_VERSION ${VERSION})
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
# Source package should always be named the same regardless of the platform on which we build
set(CPACK_SOURCE_PACKAGE_FILE_NAME "tagainijisho-${VERSION}")
set(CPACK_SOURCE_STRIP_FILES true)
set(CPACK_STRIP_FILES true)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")

# Disable all build type for safer operation. Per doc one should not set CPACK_GENERATOR directly
set(CPACK_BINARY_BUNDLE "OFF")
set(CPACK_BINARY_CYGWIN "OFF")
set(CPACK_BINARY_DEB "OFF")
set(CPACK_BINARY_DRAGNDROP "OFF")
set(CPACK_BINARY_NSIS "OFF")
set(CPACK_BINARY_OSXX11 "OFF")
set(CPACK_BINARY_PACKAGEMAKER "OFF")
set(CPACK_BINARY_RPM "OFF")
set(CPACK_BINARY_STGZ "OFF")
set(CPACK_BINARY_TBZ2 "OFF")
set(CPACK_BINARY_TGZ "OFF")
set(CPACK_BINARY_TZ "OFF")
set(CPACK_BINARY_ZIP "OFF")

set(CPACK_SOURCE_TBZ2 "OFF")
set(CPACK_SOURCE_TGZ "OFF")
set(CPACK_SOURCE_TZ "OFF")
set(CPACK_SOURCE_ZIP "OFF")

if(UNIX)
	set(CPACK_SOURCE_TGZ ON)
	if(APPLE)
		set(CPACK_BINARY_DRAGNDROP ON)
		set(CPACK_DMG_VOLUME_NAME "Tagaini Jisho")
		set(CPACK_DMG_DS_STORE "${CMAKE_CURRENT_SOURCE_DIR}/MacOS/DS_Store")
		set(CPACK_DMG_BACKGROUND_IMAGE "${CMAKE_CURRENT_SOURCE_DIR}/MacOS/background.png")
		set_target_properties(${tagaini_binary} PROPERTIES
			MACOSX_BUNDLE_BUNDLE_NAME "Tagaini Jisho"
			MACOSX_BUNDLE_BUNDLE_VERSION ${VERSION}
			MACOSX_BUNDLE_SHORT_VERSION_STRING ${VERSION}
			MACOSX_BUNDLE_LONG_VERSION_STRING ${VERSION}
			MACOSX_BUNDLE_GUI_IDENTIFIER "net.tagaini.TagainiJisho"
			MACOSX_BUNDLE_ICON_FILE appicon.icns
		)
		
		set(ROOT_DIR "${tagaini_binary}.app/Contents")
		set(EXE_DIR "${ROOT_DIR}/MacOS")
		set(DB_DIR ${EXE_DIR})
		set(I18N_DIR "${EXE_DIR}/i18n")
		set(DOC_DIR "${EXE_DIR}/doc")
		set(RESOURCES_DIR "${ROOT_DIR}/Resources")
		set(APPS "\${CMAKE_INSTALL_PREFIX}/${tagaini_binary}.app")

		# Extra Qt translations
		foreach(LANG ${UI_LANG})
			set(QMFILE "/Developer/Applications/Qt/translations/qt_${LANG}.qm")
			if(EXISTS ${QMFILE})
				install(FILES ${QMFILE} DESTINATION "${ROOT_DIR}/Translations" COMPONENT Runtime)
			endif(EXISTS ${QMFILE})
		endforeach(LANG ${UI_LANG})
	
		# Qt config
		install(CODE "file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${RESOURCES_DIR}/qt.conf\" \"[Paths]\nPlugins = PlugIns\nTranslations = Translations\n\")" COMPONENT Runtime)
		
		# Qt plugins
		install(CODE "
			file(GLOB_RECURSE QTPLUGINS \"\${CMAKE_INSTALL_PREFIX}/${EXE_DIR}/plugins/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
		include(BundleUtilities)
		fixup_bundle(\"${APPS}\" \"${QTPLUGINS}\" \"${QT_LIBRARY_DIRS}\")" COMPONENT Runtime)
	else(APPLE)
		set(CPACK_PACKAGE_NAME "tagainijisho")	
		set(ROOT_DIR share/tagainijisho)
		set(DB_DIR ${ROOT_DIR})
		set(I18N_DIR ${ROOT_DIR}/i18n)
		set(DOC_DIR ${ROOT_DIR}/doc)
		set(RESOURCES_DIR ${ROOT_DIR})

		# Desktop and icon files
		install(FILES ${CMAKE_SOURCE_DIR}/tagainijisho.desktop DESTINATION share/applications PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Runtime)
		install(FILES ${CMAKE_SOURCE_DIR}/images/tagainijisho-16x16.png DESTINATION share/icons/hicolor/16x16/apps RENAME tagainijisho.png PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Icons)
		install(FILES ${CMAKE_SOURCE_DIR}/images/tagainijisho-22x22.png DESTINATION share/icons/hicolor/22x22/apps RENAME tagainijisho.png PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Icons)
		install(FILES ${CMAKE_SOURCE_DIR}/images/tagainijisho-32x32.png DESTINATION share/icons/hicolor/32x32/apps RENAME tagainijisho.png PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Icons)
		install(FILES ${CMAKE_SOURCE_DIR}/images/tagainijisho-48x48.png DESTINATION share/icons/hicolor/48x48/apps RENAME tagainijisho.png PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Icons)
		install(FILES ${CMAKE_SOURCE_DIR}/images/tagainijisho-64x64.png DESTINATION share/icons/hicolor/64x64/apps RENAME tagainijisho.png PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Icons)
		install(FILES ${CMAKE_SOURCE_DIR}/images/tagainijisho-128x128.png DESTINATION share/icons/hicolor/128x128/apps RENAME tagainijisho.png PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Icons)
	endif(APPLE)

	# Databases
	install(FILES ${CMAKE_BINARY_DIR}/jmdict.db DESTINATION ${DB_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Databases)
	install(FILES ${CMAKE_BINARY_DIR}/kanjidic2.db DESTINATION ${DB_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Databases)
	foreach(LANG en;${DICT_LANG})
		install(FILES ${CMAKE_BINARY_DIR}/jmdict-${LANG}.db DESTINATION ${DB_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Databases)
		install(FILES ${CMAKE_BINARY_DIR}/kanjidic2-${LANG}.db DESTINATION ${DB_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Databases)
	endforeach(LANG en;${DICT_LANG})

	# i18n files
	foreach(LANG ${UI_LANG})
		install(FILES ${CMAKE_BINARY_DIR}/i18n/tagainijisho_${LANG}.qm DESTINATION ${I18N_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT I18n)
	endforeach(LANG ${UI_LANG})

	# Template files
	install(FILES ${CMAKE_SOURCE_DIR}/src/gui/jmdict/detailed_jmdict.html ${CMAKE_SOURCE_DIR}/src/gui/jmdict/detailed_jmdict.css DESTINATION ${RESOURCES_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Templates)
	install(FILES ${CMAKE_SOURCE_DIR}/src/gui/kanjidic2/detailed_kanjidic2.html ${CMAKE_SOURCE_DIR}/src/gui/kanjidic2/detailed_kanjidic2.css DESTINATION ${RESOURCES_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Templates)
	install(FILES ${CMAKE_SOURCE_DIR}/src/gui/export_template.html DESTINATION ${RESOURCES_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Templates)
	install(FILES ${CMAKE_SOURCE_DIR}/src/gui/detailed_default.html ${CMAKE_SOURCE_DIR}/src/gui/detailed_default.css DESTINATION ${RESOURCES_DIR} PERMISSIONS OWNER_READ GROUP_READ WORLD_READ COMPONENT Templates)

	# Documentation
	if (EXISTS ${CMAKE_SOURCE_DIR}/doc/manual.html)
		install(FILES ${CMAKE_SOURCE_DIR}/doc/manual.html DESTINATION ${DOC_DIR} COMPONENT Docs)
		install(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/images DESTINATION ${DOC_DIR} COMPONENT Docs)
	else(EXISTS ${CMAKE_SOURCE_DIR}/doc/manual.html)
		MESSAGE(STATUS "Warning, docs were not generated")
	endif()

	# Custom install targets
	add_custom_target(install_runtime
		${CMAKE_COMMAND}
		-D "COMPONENT=Runtime"
		-P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
	)
	add_dependencies(install_runtime tagainijisho)
	add_custom_target(install_databases
		${CMAKE_COMMAND}
		-D "COMPONENT=Databases"
		-P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
	)
	add_dependencies(install_databases databases)
	add_custom_target(install_i18n
		${CMAKE_COMMAND}
		-D "COMPONENT=I18n"
		-P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
	)
	add_dependencies(install_i18n i18n)
	add_custom_target(install_templates
		${CMAKE_COMMAND}
		-D "COMPONENT=Templates"
		-P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
	)
	add_dependencies(install_templates templates)
	add_custom_target(install_icons
		${CMAKE_COMMAND}
		-D "COMPONENT=Icons"
		-P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
	)
	add_dependencies(install_icons icons)
	add_custom_target(install_docs
		${CMAKE_COMMAND}
		-D "COMPONENT=Docs"
		-P "${CMAKE_BINARY_DIR}/cmake_install.cmake"
	)
	add_dependencies(install_docs docs)
	add_custom_target(install_nonarch)
	add_dependencies(install_nonarch install_databases install_i18n install_templates install_icons install_docs)
endif(UNIX)

if(WIN32)
	MESSAGE(STATUS "Not implemented")
endif(WIN32)

set(CPACK_SOURCE_IGNORE_FILES "~$" "\\\\.gitignore$" "^${PROJECT_SOURCE_DIR}/.git/" "^${PROJECT_SOURCE_DIR}/*.kdev4/" )

include(CPack)

=== src/gui/CMakeLists.txt ===
set(QT_USE_QTNETWORK TRUE)
include(${QT_USE_FILE})

set(tagainijisho_gui_SRCS
TJSpinBox.cc
TJLineEdit.cc
EntryFormatter.cc
RelativeDateEdit.cc
ProxyPaintEngine.cc
BookletPrintEngine.cc
BookletPrinter.cc
EntriesPrinter.cc
KanjiValidator.cc
TagsDialogs.cc
FlowLayout.cc
MultiStackedWidget.cc
EntryMenu.cc
EditEntryNotesDialog.cc
SavedSearchesOrganizer.cc
UpdateChecker.cc
SingleEntryView.cc
SearchFilterWidget.cc
EntryTypeFilterWidget.cc
TextFilterWidget.cc
StudyFilterWidget.cc
JLPTFilterWidget.cc
TagsFilterWidget.cc
NotesFilterWidget.cc
SearchBuilder.cc
SmoothScroller.cc
ScrollBarSmoothScroller.cc
EntryDelegate.cc
BatchHandler.cc
EntriesViewHelper.cc
ResultsView.cc
ResultsViewWidget.cc
SearchWidget.cc
TemplateFiller.cc
DetailedView.cc
EntryListView.cc
EntryListWidget.cc
ToolBarDetailedView.cc
TrainSettings.cc
YesNoTrainer.cc
ReadingTrainer.cc
PreferencesWindow.cc
MainWindow.cc
)

set(tagainijisho_gui_MOCS
TJSpinBox.h
TJLineEdit.h
EntryFormatter.h
DetailedView.h
EditEntryNotesDialog.h
EntryMenu.h
EntriesPrinter.h
KanjiValidator.h
MainWindow.h
MultiStackedWidget.h
PreferencesWindow.h
ReadingTrainer.h
RelativeDateEdit.h
EntryDelegate.h
EntriesViewHelper.h
ResultsView.h
ResultsViewWidget.h
SearchWidget.h
EntryListView.h
EntryListWidget.h
SearchFilterWidget.h
EntryTypeFilterWidget.h
TextFilterWidget.h
StudyFilterWidget.h
JLPTFilterWidget.h
TagsFilterWidget.h
NotesFilterWidget.h
SearchBuilder.h
SavedSearchesOrganizer.h
SingleEntryView.h
SmoothScroller.h
ScrollBarSmoothScroller.h
TagsDialogs.h
ToolBarDetailedView.h
TrainSettings.h
UpdateChecker.h
YesNoTrainer.h
)

set(tagainijisho_gui_UIS
ReadingTrainer.ui
SavedSearchesOrganizer.ui
PreferencesWindow.ui
TrainSettings.ui
AboutDialog.ui
ResultsViewWidget.ui
SearchWidget.ui
EntryListWidget.ui
EntryDelegatePreferences.ui
DetailedViewPreferences.ui
ResultsViewPreferences.ui
ListsViewPreferences.ui
GeneralPreferences.ui
DataPreferences.ui
MainWindow.ui
)

# Add rules for jmdict and kanjidic components
add_subdirectory(jmdict)
add_subdirectory(kanjidic2)

qt4_wrap_cpp(tagainijisho_gui_MOC_SRCS ${tagainijisho_gui_MOCS})
qt4_wrap_ui(tagainijisho_gui_UI_SRCS ${tagainijisho_gui_UIS})
qt4_add_resources(tagainijisho_gui_RC ${CMAKE_SOURCE_DIR}/tagainijisho.qrc)

include_directories(${QT_INCLUDE_DIR})

add_library(tagaini_gui STATIC ${tagainijisho_gui_UI_SRCS} ${tagainijisho_gui_MOC_SRCS} ${tagainijisho_gui_SRCS})

# Build the main program
SET(ICON "")
if(APPLE)
	SET_SOURCE_FILES_PROPERTIES(appicon.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	set(ICON ${CMAKE_CURRENT_SOURCE_DIR}/appicon.icns)
endif(APPLE)

set(tagainijisho_SRCS main.cc ${tagainijisho_gui_RC} ${ICON})

if (WIN32)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/tagainijisho_rc.obj COMMAND i486-mingw32-windres -I${CMAKE_SOURCE_DIR}/src/gui -i${CMAKE_SOURCE_DIR}/src/gui/tagainijisho.rc -o ${CMAKE_CURRENT_BINARY_DIR}/tagainijisho_rc.obj)
	set(tagainijisho_SRCS ${tagainijisho_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/tagainijisho_rc.obj)
endif()

if (APPLE)
	set(tagainijisho_SRCS ${tagainijisho_SRCS} ${MACOSX_BUNDLE_ICON_FILE})
endif()

add_executable(${tagaini_binary} MACOSX_BUNDLE WIN32 ${tagainijisho_SRCS})
target_link_libraries(${tagaini_binary} tagaini_gui_jmdict tagaini_gui_kanjidic2 tagaini_gui tagaini_core_jmdict tagaini_core_kanjidic2 tagaini_core ${QT_LIBRARIES} ${extra_link_flags})
install(TARGETS ${tagaini_binary} BUNDLE DESTINATION . COMPONENT Runtime RUNTIME DESTINATION bin COMPONENT Runtime)

# If needed, add standard dependency to have identical build on all platforms
if (NOT ${tagaini_binary} MATCHES "tagainijisho")
	add_custom_target(tagainijisho DEPENDS ${tagaini_binary})
endif()

if (BUILD_TESTS)
	add_subdirectory(tests)
endif()

=== src/sqlite/CMakeLists.txt ===
set(QT_DONT_USE_QTGUI TRUE)
include(${QT_USE_FILE})

set(SQLITE_MIN_VERSION "3007004")
set(SQLITE_BLACKLIST "3007007;3007008")
set(SQLITE_DOWNLOAD_VERSION "3071100")

set(SQLITE_SOURCE http://www.sqlite.org/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)

option(SHARED_SQLITE_LIBRARY "Build the SQLite library as a shared library (loadable by SQLite's interpreter)" OFF)

# Embed SQLite even if the system version looks good?
option(EMBED_SQLITE "Embed SQLite even if a system version is present and valid" OFF)

# Look for system SQLite
find_path(SQLITE_INCLUDE_DIR sqlite3.h)
find_library(SQLITE_LIBRARY
	NAMES sqlite sqlite3
	DOC "SQLite library"
)
if(SQLITE_INCLUDE_DIR AND SQLITE_LIBRARY AND NOT EMBED_SQLITE)
	file(STRINGS ${SQLITE_INCLUDE_DIR}/sqlite3.h SQLITE_VERSION LIMIT_COUNT 1 REGEX "#define SQLITE_VERSION_NUMBER ")
	string(REGEX REPLACE "#define SQLITE_VERSION_NUMBER +(.+)" "\\1" SQLITE_VERSION ${SQLITE_VERSION})
	string(COMPARE GREATER "${SQLITE_VERSION}" "${SQLITE_MIN_VERSION}" FOUND_SQLITE)
	if(NOT FOUND_SQLITE)
		string(COMPARE EQUAL "${SQLITE_VERSION}" "${SQLITE_MIN_VERSION}" FOUND_SQLITE)
	endif()
	foreach(BANNED_VERSION ${SQLITE_BLACKLIST})
		string(COMPARE EQUAL "${SQLITE_VERSION}" "${BANNED_VERSION}" IS_BANNED)
		if (IS_BANNED)
			break()
		endif()
	endforeach()
	if(FOUND_SQLITE)
		if (IS_BANNED)
			message(STATUS "Found sqlite3 version ${SQLITE_VERSION}, but this version has been blacklisted. Embedding version ${SQLITE_DOWNLOAD_VERSION} instead")
			set(EMBED_SQLITE TRUE)
		else()
			message(STATUS "Found sqlite3 version ${SQLITE_VERSION} (using ${SQLITE_INCLUDE_DIR}/sqlite3.h)")
		endif()
	else()
		message(STATUS "Found sqlite3 version ${SQLITE_VERSION} but version ${SQLITE_MIN_VERSION} or greater required, embedding version ${SQLITE_DOWNLOAD_VERSION}")
		set(EMBED_SQLITE TRUE)
	endif()
elseif(NOT EMBED_SQLITE)
	message(STATUS "System sqlite3 not found, embedding version ${SQLITE_DOWNLOAD_VERSION}...")
	set(SQLITE_VERSION ${SQLITE_DOWNLOAD_VERSION}})
	set(EMBED_SQLITE TRUE)
endif()

# Need to download SQLite?
if(EMBED_SQLITE AND NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3.c)
	message(STATUS "Downloading SQLite ${SQLITE_DOWNLOAD_VERSION} from ${SQLITE_SOURCE}")
	file(DOWNLOAD ${SQLITE_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)
	execute_process(COMMAND cmake -E tar xvf ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
	file(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty/sqlite)
	file(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}/sqlite3.c ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3.c)
	file(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}/sqlite3.h ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3.h)
	file(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}/sqlite3ext.h ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3ext.h)
	file(REMOVE ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)
	file(REMOVE_RECURSE ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION})
endif()

set(tagainijisho_sqlite_SRCS
Error.cc
Connection.cc
Query.cc
sqlite3ext.cc
sqlite3mod.c
# TODO Lame!
${CMAKE_SOURCE_DIR}/src/core/TextTools.cc
)

if(EMBED_SQLITE)
	include_directories(${CMAKE_SOURCE_DIR}/3rdparty/sqlite)
	set(tagainijisho_sqlite_SRCS
		${tagainijisho_sqlite_SRCS}
		${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3.c
	)
else()
	include_directories(${SQLITE_INCLUDE_DIR})
endif()

include_directories(${QT_INCLUDE_DIR})
add_definitions(-DSQLITE_ENABLE_FTS3 -DSQLITE_ENABLE_FTS3_PARENTHESIS -DSQLITE_ENABLE_LOCKING_STYLE=0 -DSQLITE_OMIT_DEPRECATED)

if(SHARED_SQLITE_LIBRARY)
	add_library(tagaini_sqlite SHARED ${tagainijisho_sqlite_SRCS} ${tagainijisho_sqlite_MOC_SRCS})
	target_link_libraries(tagaini_sqlite ${QT_LIBRARIES} ${extra_link_flags})
	install(TARGETS tagaini_sqlite BUNDLE DESTINATION . COMPONENT Runtime LIBRARY DESTINATION lib COMPONENT Runtime)
else()
	add_library(tagaini_sqlite STATIC ${tagainijisho_sqlite_SRCS} ${tagainijisho_sqlite_MOC_SRCS})
endif()
if(NOT EMBED_SQLITE)
	target_link_libraries(tagaini_sqlite sqlite3)
endif()

if(APPLE)
        set(DEST_DIR "${tagaini_binary}.app/Contents/MacOS")
else(APPLE)
        set(DEST_DIR "lib")
endif(APPLE)

if (BUILD_TESTS)
add_subdirectory(tests)
endif()

=== src/core/jmdict/CMakeLists.txt ===
# JMdict core
set(QT_DONT_USE_QTGUI TRUE)

# JMdict
set(JMDICT_SOURCE ftp://ftp.monash.edu.au/pub/nihongo/JMdict.gz)
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/JMdict)
	MESSAGE(STATUS "Downloading JMdict from ${JMDICT_SOURCE}")
	FILE(DOWNLOAD ${JMDICT_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/JMdict.gz)
	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/JMdict.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
endif()

# JMdictDescs
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/JMdictDescs.cc)
	MESSAGE(STATUS "Generating JMdictDescs")
	FILE(STRINGS ${CMAKE_SOURCE_DIR}/3rdparty/JMdict LINES REGEX ENTITY)
	foreach(LINE ${LINES})
		STRING(REGEX REPLACE ".*\\\"(.*)\\\">" "\\1" result "${LINE}" )
		FILE(APPEND ${CMAKE_SOURCE_DIR}/3rdparty/JMdictDescs.cc "QT_TRANSLATE_NOOP(\"JMdictLongDescs\", \"${result}\");\n")
	endforeach(LINE ${LINES})
endif()

set(tagainijisho_core_jmdict_SRCS
JMdictEntry.cc
JMdictEntrySearcher.cc
JMdictEntryLoader.cc
JMdictPlugin.cc
)

set(tagainijisho_core_jmdict_MOCS
JMdictEntry.h
JMdictEntrySearcher.h
)

qt4_wrap_cpp(tagainijisho_core_jmdict_MOC_SRCS ${tagainijisho_core_jmdict_MOCS})
add_library(tagaini_core_jmdict STATIC ${tagainijisho_core_jmdict_MOC_SRCS} ${tagainijisho_core_jmdict_SRCS})

# Database builder
set(QT_USE_QTXML TRUE)
set(build_jmdict_db_SRCS
JMdictParser.cc
BuildJMdictDB.cc
../XmlParserHelper.cc
)

include(${QT_USE_FILE})
add_executable(build_jmdict_db EXCLUDE_FROM_ALL ${build_jmdict_db_SRCS})
target_link_libraries(build_jmdict_db tagaini_sqlite ${QT_LIBRARIES})

# Database target. Always build the english DB, other languages are optional.
set(ALL_LANGS "en")
foreach(LANG ${DICT_LANG})
	set(ALL_LANGS "${ALL_LANGS},${LANG}")
endforeach()
add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/jmdict.db
	COMMAND build_jmdict_db -l${ALL_LANGS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
	DEPENDS build_jmdict_db ${CMAKE_SOURCE_DIR}/3rdparty/JMdict)
add_custom_target(jmdict-db DEPENDS ${CMAKE_BINARY_DIR}/jmdict.db)
add_dependencies(databases jmdict-db)

=== src/core/kanjidic2/CMakeLists.txt ===
# kanjidic2 and KanjiVG core
set(QT_DONT_USE_QTGUI TRUE)

set(KANJIDIC2_SOURCE http://www.csse.monash.edu.au/~jwb/kanjidic2/kanjidic2.xml.gz)
set(KANJIVG_SOURCE https://github.com/downloads/KanjiVG/kanjivg/kanjivg-20120401.xml.gz)

# Kanjidic2
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml)
	MESSAGE(STATUS "Downloading Kanjidic2 from ${KANJIDIC2_SOURCE}")
	FILE(DOWNLOAD ${KANJIDIC2_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz)
	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
endif()

# KanjiVG
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg.xml)
	MESSAGE(STATUS "Downloading KanjiVG from ${KANJIVG_SOURCE}")
	FILE(DOWNLOAD ${KANJIVG_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz)
	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
	FILE(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg.xml)
endif()

set(tagainijisho_core_kanjidic2_SRCS
Kanjidic2Entry.cc
Kanjidic2EntrySearcher.cc
Kanjidic2EntryLoader.cc
KanjiRadicals.cc
Kanjidic2Plugin.cc
)

set(tagainijisho_core_kanjidic2_MOCS
Kanjidic2Entry.h
)

qt4_wrap_cpp(tagainijisho_core_kanjidic2_MOC_SRCS ${tagainijisho_core_kanjidic2_MOCS})
add_library(tagaini_core_kanjidic2 STATIC ${tagainijisho_core_kanjidic2_MOC_SRCS} ${tagainijisho_core_kanjidic2_SRCS})

# Database builder
set(QT_USE_QTXML TRUE)
set(build_kanji_db_SRCS
Kanjidic2Parser.cc
KanjiVGParser.cc
BuildKanjiDB.cc
../XmlParserHelper.cc
)

include(${QT_USE_FILE})
add_executable(build_kanji_db EXCLUDE_FROM_ALL ${build_kanji_db_SRCS})
target_link_libraries(build_kanji_db tagaini_sqlite ${QT_LIBRARIES})

# Database target. Always build the english DB, other languages are optional.
set(ALL_LANGS "en")
foreach(LANG ${DICT_LANG})
	set(ALL_LANGS "${ALL_LANGS},${LANG}")
endforeach()
add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/kanjidic2.db
	COMMAND build_kanji_db -l${ALL_LANGS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
	DEPENDS build_kanji_db ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg.xml)
add_custom_target(kanjidic2-db DEPENDS ${CMAKE_BINARY_DIR}/kanjidic2.db)
add_dependencies(databases kanjidic2-db)

=== src/core/tatoeba/CMakeLists.txt ===
# Tatoeba core
set(QT_DONT_USE_QTGUI TRUE)

set(TATOEBA_SENTENCES_SOURCE http://tatoeba.org/files/downloads/sentences.csv)
set(TATOEBA_LINKS_SOURCE http://tatoeba.org/files/downloads/links.csv)
set(TATOEBA_INDICES_SOURCE http://tatoeba.org/files/downloads/jpn_indices.csv)

# Tatoeba
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/sentences.csv)
FILE(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba)
MESSAGE(STATUS "Downloading Tatoeba sentences from ${TATOEBA_SENTENCES_SOURCE}")
FILE(DOWNLOAD ${TATOEBA_SENTENCES_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/sentences.csv)
endif()
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/links.csv)
FILE(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba)
MESSAGE(STATUS "Downloading Tatoeba links from ${TATOEBA_LINKS_SOURCE}")
FILE(DOWNLOAD ${TATOEBA_LINKS_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/links.csv)
endif()
if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/jpn_indices.csv)
FILE(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba)
MESSAGE(STATUS "Downloading Tatoeba indices from ${TATOEBA_INDICES_SOURCE}")
FILE(DOWNLOAD ${TATOEBA_INDICES_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/jpn_indices.csv)
endif()

set(tagainijisho_core_tatoeba_SRCS
TatoebaEntry.cc
TatoebaEntryLoader.cc
TatoebaPlugin.cc
)

set(tagainijisho_core_tatoeba_MOCS
TatoebaEntry.h
)

qt4_wrap_cpp(tagainijisho_core_tatoeba_MOC_SRCS ${tagainijisho_core_tatoeba_MOCS})
add_library(tagaini_core_tatoeba STATIC ${tagainijisho_core_tatoeba_MOC_SRCS} ${tagainijisho_core_tatoeba_SRCS})
add_dependencies(tagaini_core_tatoeba tagaini_core)

# Database builder
set(QT_USE_QTXML TRUE)
set(build_tatoeba_db_SRCS
BuildTatoebaDB.cc
)

include(${QT_USE_FILE})
add_executable(build_tatoeba_db EXCLUDE_FROM_ALL ${build_tatoeba_db_SRCS})
target_link_libraries(build_tatoeba_db tagaini_sqlite ${QT_LIBRARIES})

# Database target. Always build the english DB, other languages are optional.
set(ALL_LANGS "en")
foreach(LANG ${DICT_LANG})
	set(ALL_LANGS "${ALL_LANGS},${LANG}")
endforeach()
add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/tatoeba.db
	COMMAND build_tatoeba_db -l${ALL_LANGS} ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR}
	DEPENDS build_tatoeba_db ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/sentences.csv ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/links.csv ${CMAKE_SOURCE_DIR}/3rdparty/tatoeba/jpn_indices.csv ${CMAKE_BINARY_DIR}/jmdict.db)
add_custom_target(tatoeba-db DEPENDS ${CMAKE_BINARY_DIR}/tatoeba.db)
add_dependencies(databases tatoeba-db)

=== debian/changelog ===
tagainijisho (0.9.4-1) unstable; urgency=low

  * New upstream release
  * Enable hardened build
  * Enabled --as-needed
  * Switch to education section

 -- Thibaut VARENE <varenet@debian.org>  Fri, 11 May 2012 18:18:18 +0200

=== debian/control ===
Source: tagainijisho
Section: education
Priority: extra
Maintainer: Thibaut VARENE <varenet@debian.org>
Build-Depends: debhelper (>= 8), libqt4-dev (>= 4.5), cmake (>= 2.6), libsqlite3-dev (>= 3.7.9), dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.3
Homepage: http://www.tagaini.net/

Package: tagainijisho
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tagainijisho-common (= ${source:Version}), tagainijisho-dic-en (= ${source:Version})
Description: Japanese dictionary and learning assistant
 Tagaini Jisho is a Japanese vocabulary and kanji dictionary that aims at
 presenting results in a way that makes it easy to create connections
 in your mind and remember them. To allow this, it keeps track of all the
 entries you already know and allows you to tag and add notes to them. It
 also features kanji drawing animations for more than 6000 kanjis,
 flashcard-like training, production of paper material for studying,
 and extended search options for vocabulary and kanjis including
 part-of-speech and JLPT levels.

Package: tagainijisho-common
Architecture: all
Depends: ${misc:Depends}
Replaces: tagainijisho (<< 0.9.2-1)
Breaks: tagainijisho (<< 0.9.2-1)
Recommends: tagainijisho
Description: Common files for Tagaini Jisho
 Contains the main databases files, documentation and other common files for
 the tagainijisho package.

Package: tagainijisho-dic-en
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: English dictionary files for Tagaini Jisho
 Contains the English dictionary files for the tagainijisho package.

Package: tagainijisho-dic-fr
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: French dictionary files for Tagaini Jisho
 Contains the French dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-de
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: German dictionary files for Tagaini Jisho
 Contains the German dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-es
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Spanish dictionary files for Tagaini Jisho
 Contains the Spanish dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-ru
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Russian dictionary files for Tagaini Jisho
 Contains the Russian dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-it
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Italian dictionary files for Tagaini Jisho
 Contains the Italian dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-pt
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Portuguese dictionary files for Tagaini Jisho
 Contains the Portuguese dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-th
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Thai dictionary files for Tagaini Jisho
 Contains the Thai dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

Package: tagainijisho-dic-tr
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Turkish dictionary files for Tagaini Jisho
 Contains the Turkish dictionary files for the tagainijisho package. Entries
 for which a translation is not available are displayed in English.

## tagainijisho 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # Set the program name to be the same as the project
 set(tagaini_binary ${CMAKE_PROJECT_NAME})
 
-set(VERSION 0.9.4)
+set(VERSION 1.0.1)
 
 cmake_minimum_required(VERSION 2.8.0)
 
@@ -30,12 +30,11 @@
 # 64 bits Intel binary with 10.6 compatibility 
 if(APPLE)
 	set(CMAKE_OSX_ARCHITECTURES "${ARCHS_STANDARD_64_BIT}")
-	set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk")
+	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.8.sdk")
 	set(CMAKE_OSX_DEPLOYMENT_TARGET "10.6")
 	set(CMAKE_PREFIX_PATH "${CMAKE_OSX_SYSROOT}/usr")  
 	set(CMAKE_FRAMEWORK_PATH "${CMAKE_OSX_SYSROOT}/Library/Frameworks:${CMAKE_OSX_SYSROOT}/System/")
-	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -sectcreate __TEXT __info_plist ${CMAKE_BINARY_DIR}/src/gui/Tagaini\\ Jisho.app/Contents/Info.plist")
-	set(extra_link_flags "-bind_at_load")
+	set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/pack/MacOS/")
 endif(APPLE)
 if(WIN32)
 	set(extra_link_flags "-static-libgcc -static-libstdc++ -mwindows")

=== src/CMakeLists.txt ===
include(${QT_USE_FILE})

# Make useful CMake definitions visible to the code
configure_file(tagaini_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/tagaini_config.h)

# For config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})
# For our own headers
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(sqlite)
add_subdirectory(core)
add_subdirectory(gui)

=== src/sqlite/CMakeLists.txt ===
--- 
+++ 
@@ -2,15 +2,20 @@
 include(${QT_USE_FILE})
 
 set(SQLITE_MIN_VERSION "3007004")
-set(SQLITE_BLACKLIST "3007007;3007008")
-set(SQLITE_DOWNLOAD_VERSION "3071100")
+set(SQLITE_BLACKLIST "3007007;3007008;3008000")
+set(SQLITE_DOWNLOAD_VERSION "3080100")
 
-set(SQLITE_SOURCE http://www.sqlite.org/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)
+set(SQLITE_SOURCE http://www.sqlite.org/2013/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)
 
 option(SHARED_SQLITE_LIBRARY "Build the SQLite library as a shared library (loadable by SQLite's interpreter)" OFF)
 
 # Embed SQLite even if the system version looks good?
 option(EMBED_SQLITE "Embed SQLite even if a system version is present and valid" OFF)
+
+# Force embedded version on Apple
+if (APPLE)
+	set (EMBED_SQLITE "ON")  
+endif(APPLE)
 
 # Look for system SQLite
 find_path(SQLITE_INCLUDE_DIR sqlite3.h)
@@ -51,7 +56,7 @@
 # Need to download SQLite?
 if(EMBED_SQLITE AND NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3.c)
 	message(STATUS "Downloading SQLite ${SQLITE_DOWNLOAD_VERSION} from ${SQLITE_SOURCE}")
-	file(DOWNLOAD ${SQLITE_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)
+	file(DOWNLOAD ${SQLITE_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip SHOW_PROGRESS)
 	execute_process(COMMAND cmake -E tar xvf ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
 	file(MAKE_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty/sqlite)
 	file(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}/sqlite3.c ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3.c)
@@ -59,6 +64,8 @@
 	file(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}/sqlite3ext.h ${CMAKE_SOURCE_DIR}/3rdparty/sqlite/sqlite3ext.h)
 	file(REMOVE ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION}.zip)
 	file(REMOVE_RECURSE ${CMAKE_SOURCE_DIR}/3rdparty/sqlite-amalgamation-${SQLITE_DOWNLOAD_VERSION})
+elseif(EMBED_SQLITE)
+	message(STATUS "Embedding SQLite ${SQLITE_DOWNLOAD_VERSION}")
 endif()
 
 set(tagainijisho_sqlite_SRCS
@@ -95,6 +102,11 @@
 	target_link_libraries(tagaini_sqlite sqlite3)
 endif()
 
+if(UNIX)
+	target_link_libraries(tagaini_sqlite pthread)
+	target_link_libraries(tagaini_sqlite dl)
+endif(UNIX)
+
 if(APPLE)
         set(DEST_DIR "${tagaini_binary}.app/Contents/MacOS")
 else(APPLE)

=== src/core/kanjidic2/CMakeLists.txt ===
--- 
+++ 
@@ -2,20 +2,26 @@
 set(QT_DONT_USE_QTGUI TRUE)
 
 set(KANJIDIC2_SOURCE http://www.csse.monash.edu.au/~jwb/kanjidic2/kanjidic2.xml.gz)
-set(KANJIVG_SOURCE https://github.com/downloads/KanjiVG/kanjivg/kanjivg-20120401.xml.gz)
+set(KANJIVG_SOURCE https://github.com/KanjiVG/kanjivg/releases/download/r20130901/kanjivg-20130901.xml.gz)
 
 # Kanjidic2
 if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml)
 	MESSAGE(STATUS "Downloading Kanjidic2 from ${KANJIDIC2_SOURCE}")
-	FILE(DOWNLOAD ${KANJIDIC2_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz)
-	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
+	FILE(DOWNLOAD ${KANJIDIC2_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz SHOW_PROGRESS)
+	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty RESULT_VARIABLE result)
+	if(NOT "${result}" STREQUAL 0)
+		MESSAGE(FATAL_ERROR "Unable to run [${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjidic2.xml.gz]. Reported error was [${result}]")
+	endif(NOT "${result}" STREQUAL 0)
 endif()
 
 # KanjiVG
 if(NOT EXISTS ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg.xml)
 	MESSAGE(STATUS "Downloading KanjiVG from ${KANJIVG_SOURCE}")
-	FILE(DOWNLOAD ${KANJIVG_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz)
-	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty)
+	FILE(DOWNLOAD ${KANJIVG_SOURCE} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz SHOW_PROGRESS)
+	execute_process(COMMAND ${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/3rdparty RESULT_VARIABLE result)
+	if(NOT "${result}" STREQUAL 0)
+		MESSAGE(FATAL_ERROR "Unable to run [${GUNZIP} ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml.gz]. Reported error was [${result}]")
+	endif(NOT "${result}" STREQUAL 0)
 	FILE(RENAME ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg-latest.xml ${CMAKE_SOURCE_DIR}/3rdparty/kanjivg.xml)
 endif()

=== src/gui/tests/CMakeLists.txt ===
set(QT_USE_QTTEST TRUE)
include(${QT_USE_FILE})

set(gui_tests_SRCS
TemplateFillerTests.cc
)

qt4_wrap_cpp(gui_tests_MOC_SRCS
TemplateFillerTests.h
)

include_directories(${QT_INCLUDE_DIR})
add_executable(guitests ${gui_tests_SRCS} ${gui_tests_MOC_SRCS})
target_link_libraries(guitests tagaini_gui ${QT_LIBRARIES})

=== debian/changelog ===
tagainijisho (1.0.1-1) unstable; urgency=low

  * New upstream release (Closes: #729782)
  * Clarify descriptions (Closes: #672717)

 -- Thibaut VARENE <varenet@debian.org>  Fri, 29 Nov 2013 13:04:28 +0100

=== debian/control ===
Source: tagainijisho
Section: education
Priority: extra
Maintainer: Thibaut VARENE <varenet@debian.org>
Build-Depends: debhelper (>= 8), libqt4-dev (>= 4.5), cmake (>= 2.6), libsqlite3-dev (>= 3.8.1), dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.4
Homepage: http://www.tagaini.net/

Package: tagainijisho
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tagainijisho-common (= ${source:Version}), tagainijisho-dic-en (= ${source:Version})
Description: Japanese dictionary and learning assistant
 Tagaini Jisho is a free, open-source Japanese dictionary and kanji
 lookup tool.
 .
 It aims at becoming your Japanese study assistant by allowing you 
 to quickly search for entries and mark those that you wish to study, 
 along with tags and personal notes. It also let you train entries 
 you are studying and follows your progression in remembering them. 
 Finally, it makes it easy to review entries you did not remember 
 by listing them on screen or printing them on a small booklet.
 . 
 Tagaini Jisho also features complete stroke order animations for more
 than 6000 kanji, flashcard-like training, production of paper material 
 for studying, and extended search options for vocabulary and kanjis 
 including part-of-speech and JLPT levels.

Package: tagainijisho-common
Architecture: all
Depends: ${misc:Depends}
Replaces: tagainijisho (<< 0.9.2-1)
Breaks: tagainijisho (<< 0.9.2-1)
Recommends: tagainijisho
Description: Common files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the main databases files, documentation 
 and other common files for the tagainijisho package.

Package: tagainijisho-dic-en
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: English dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-English dictionary files for 
 the tagainijisho package.

Package: tagainijisho-dic-fr
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: French dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-French dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-de
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: German dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-German dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-es
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Spanish dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-Spanish dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-ru
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Russian dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-Russian dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-it
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Italian dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-Italian dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-pt
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Portuguese dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-Portuguese dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-th
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Thai dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-Thai dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

Package: tagainijisho-dic-tr
Architecture: all
Depends: ${misc:Depends}
Recommends: tagainijisho
Description: Turkish dictionary files for Tagaini Jisho
 Tagaini Jisho is a Japanese dictionary and learning assistant.
 .
 This package contains the Japanese-Turkish dictionary files for 
 the tagainijisho package.
 .
 Entries for which a translation is not available are displayed 
 in English.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# To enable all, uncomment following line
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)


configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	mkdir build
	cd build && cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr ../
	touch $@


#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 
	# Add here commands to compile the arch part of the package.
	$(MAKE) VERBOSE=1 -C build tagainijisho
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp 
	# Add here commands to compile the indep part of the package.
	$(MAKE) VERBOSE=1 -C build i18n databases
	touch $@

clean:
	dh_testdir
	dh_testroot
	-rm -f build-arch-stamp build-indep-stamp configure-stamp
	# Add here commands to clean up after the build process.
	-rm -rf build
	dh_clean 


install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) -C build install DESTDIR=$(CURDIR)/debian/tmp
	dh_install --list-missing

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep -a
	dh_installdirs -a
	$(MAKE) -C build install_runtime DESTDIR=$(CURDIR)/debian/tmp
	dh_install -a --list-missing

install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep -i
	dh_installdirs -i
	$(MAKE) -C build install_nonarch DESTDIR=$(CURDIR)/debian/tmp
	dh_install -i --list-missing


# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installdocs --link-doc=tagainijisho-common
	dh_installchangelogs 
#	dh_installexamples
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-arch install-indep
